/* ╔════════════════╦══════════════════════════╗
   ║    John Breaux ║    JohnBreaux@my.unt.edu ║
   ║ Gabriel Castro ║ GabrielCastro@my.unt.edu ║
   ║ Michael Laymon ║ MichaelLaymon@my.unt.edu ║
   ╠════════════════╩══════════════════════════╣
   ║  Created 2022-04-16   Updated 2022-04-28  ║
   ╚═══════════════════════════════════════════╝  */

#include <string>

#include "graph.hpp" // graph, Graph reduction/Knot detection

int main (int argc, char **argv) {
   // If not enough arguments, print usage
   if (argc < 2) {
      printf("Usage: %s [filename]", argv[0]);
      return 1;
   }
   // Grab the filename from args
   std::string filename = argv[1];
   // Construct a graph
   graph g;

   // Read from a file, and print the result
   int err = g.read (filename);
   if (err) {
      return err;
   }
   g.print ();
   // Graph reduction
   printf ("Graph is %s\n\n", g.reducible () ? "not reducible! Deadlock!" : "reducible! No deadlock!");
   // Knot detection (broken. Algorithm isn't right)
   // printf ("Graph is %s\n\n", g.knotted () ? "knotted! Deadlock!" : "not knotted! No deadlock!");
   return 0;
}
